diff --git a/configure.ac b/configure.ac
index 97f0af400..dd82b66ec 100644
--- a/configure.ac
+++ b/configure.ac
@@ -181,14 +181,13 @@ AS_CASE([$host],
   [powerpc*], [ARCH_ABI=power64-linux],
   [aarch64*], [ARCH_ABI=arm64-linux],
   [arm*],     [ARCH_ABI=arm32-linux],
-  [ARCH_ABI=undefined]
+  [ARCH_ABI=default-linux]
 )
 AC_SUBST([ARCH_ABI])
 
-if test "${ARCH_ABI}" = "undefined";
+if test "${ARCH_ABI}" = "default-linux";
 then
-    echo "ARCH_ABI is undefined, please add your ARCH_ABI based on host=${host}"
-    exit 1
+    AC_MSG_WARN([ARCH_ABI is undefined, please add your ARCH_ABI based on host=${host}])
 fi
 
 ##########################################################################
diff --git a/include/Makefile.am b/include/Makefile.am
index aa330b8d4..512002f87 100644
--- a/include/Makefile.am
+++ b/include/Makefile.am
@@ -226,6 +226,44 @@ odpapiabiarchinclude_HEADERS = \
 	odp/arch/arm64-linux/odp/api/abi/traffic_mngr.h \
 	odp/arch/arm64-linux/odp/api/abi/version.h
 endif
+if ARCH_IS_DEFAULT
+odpapiabiarchinclude_HEADERS = \
+	odp/arch/default-linux/odp/api/abi/align.h \
+	odp/arch/default-linux/odp/api/abi/atomic.h \
+	odp/arch/default-linux/odp/api/abi/barrier.h \
+	odp/arch/default-linux/odp/api/abi/buffer.h \
+	odp/arch/default-linux/odp/api/abi/byteorder.h \
+	odp/arch/default-linux/odp/api/abi/classification.h \
+	odp/arch/default-linux/odp/api/abi/cpu.h \
+	odp/arch/default-linux/odp/api/abi/cpumask.h \
+	odp/arch/default-linux/odp/api/abi/crypto.h \
+	odp/arch/default-linux/odp/api/abi/debug.h \
+	odp/arch/default-linux/odp/api/abi/event.h \
+	odp/arch/default-linux/odp/api/abi/init.h \
+	odp/arch/default-linux/odp/api/abi/ipsec.h \
+	odp/arch/default-linux/odp/api/abi/packet.h \
+	odp/arch/default-linux/odp/api/abi/packet_flags.h \
+	odp/arch/default-linux/odp/api/abi/packet_io.h \
+	odp/arch/default-linux/odp/api/abi/pool.h \
+	odp/arch/default-linux/odp/api/abi/queue.h \
+	odp/arch/default-linux/odp/api/abi/rwlock.h \
+	odp/arch/default-linux/odp/api/abi/rwlock_recursive.h \
+	odp/arch/default-linux/odp/api/abi/schedule.h \
+	odp/arch/default-linux/odp/api/abi/schedule_types.h \
+	odp/arch/default-linux/odp/api/abi/shared_memory.h \
+	odp/arch/default-linux/odp/api/abi/spinlock.h \
+	odp/arch/default-linux/odp/api/abi/spinlock_recursive.h \
+	odp/arch/default-linux/odp/api/abi/std_clib.h \
+	odp/arch/default-linux/odp/api/abi/std_types.h \
+	odp/arch/default-linux/odp/api/abi/sync.h \
+	odp/arch/default-linux/odp/api/abi/thread.h \
+	odp/arch/default-linux/odp/api/abi/thrmask.h \
+	odp/arch/default-linux/odp/api/abi/ticketlock.h \
+	odp/arch/default-linux/odp/api/abi/time.h \
+	odp/arch/default-linux/odp/api/abi/timer.h \
+	odp/arch/default-linux/odp/api/abi/traffic_mngr.h \
+	odp/arch/default-linux/odp/api/abi/version.h
+endif
 if ARCH_IS_MIPS64
 odpapiabiarchinclude_HEADERS = \
 	odp/arch/mips64-linux/odp/api/abi/align.h \
diff --git a/include/odp/arch/default-linux/odp/api/abi/align.h b/include/odp/arch/default-linux/odp/api/abi/align.h
new file mode 100644
index 000000000..a4692f5db
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/align.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/align.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/atomic.h b/include/odp/arch/default-linux/odp/api/abi/atomic.h
new file mode 100644
index 000000000..df1c2cd94
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/atomic.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/atomic.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/barrier.h b/include/odp/arch/default-linux/odp/api/abi/barrier.h
new file mode 100644
index 000000000..5ccdf0179
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/barrier.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/barrier.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/buffer.h b/include/odp/arch/default-linux/odp/api/abi/buffer.h
new file mode 100644
index 000000000..e030559aa
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/buffer.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/buffer.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/byteorder.h b/include/odp/arch/default-linux/odp/api/abi/byteorder.h
new file mode 100644
index 000000000..27219f946
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/byteorder.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/byteorder.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/classification.h b/include/odp/arch/default-linux/odp/api/abi/classification.h
new file mode 100644
index 000000000..4c3ba3271
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/classification.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/classification.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/cpu.h b/include/odp/arch/default-linux/odp/api/abi/cpu.h
new file mode 100644
index 000000000..0765339b4
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/cpu.h
@@ -0,0 +1,24 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#ifndef ODP_API_ABI_CPU_H_
+#define ODP_API_ABI_CPU_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define ODP_CACHE_LINE_SIZE 64
+
+static inline void odp_cpu_pause(void)
+{
+}
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff --git a/include/odp/arch/default-linux/odp/api/abi/cpumask.h b/include/odp/arch/default-linux/odp/api/abi/cpumask.h
new file mode 100644
index 000000000..b4e7a5df0
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/cpumask.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/cpumask.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/crypto.h b/include/odp/arch/default-linux/odp/api/abi/crypto.h
new file mode 100644
index 000000000..4f4b4368b
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/crypto.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/crypto.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/debug.h b/include/odp/arch/default-linux/odp/api/abi/debug.h
new file mode 100644
index 000000000..1bc031090
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/debug.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/debug.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/event.h b/include/odp/arch/default-linux/odp/api/abi/event.h
new file mode 100644
index 000000000..f87d61951
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/event.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/event.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/init.h b/include/odp/arch/default-linux/odp/api/abi/init.h
new file mode 100644
index 000000000..bd64cf14d
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/init.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/init.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/ipsec.h b/include/odp/arch/default-linux/odp/api/abi/ipsec.h
new file mode 100644
index 000000000..5073680b7
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/ipsec.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/ipsec.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/packet.h b/include/odp/arch/default-linux/odp/api/abi/packet.h
new file mode 100644
index 000000000..a1e9b1a83
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/packet.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/packet.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/packet_flags.h b/include/odp/arch/default-linux/odp/api/abi/packet_flags.h
new file mode 100644
index 000000000..fd3e10d0e
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/packet_flags.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/packet_flags.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/packet_io.h b/include/odp/arch/default-linux/odp/api/abi/packet_io.h
new file mode 100644
index 000000000..e4220c63c
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/packet_io.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/packet_io.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/pool.h b/include/odp/arch/default-linux/odp/api/abi/pool.h
new file mode 100644
index 000000000..720556359
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/pool.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/pool.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/queue.h b/include/odp/arch/default-linux/odp/api/abi/queue.h
new file mode 100644
index 000000000..04f0c6eb8
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/queue.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/queue.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/rwlock.h b/include/odp/arch/default-linux/odp/api/abi/rwlock.h
new file mode 100644
index 000000000..a6aa377db
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/rwlock.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/rwlock.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/rwlock_recursive.h b/include/odp/arch/default-linux/odp/api/abi/rwlock_recursive.h
new file mode 100644
index 000000000..a78a2181f
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/rwlock_recursive.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/rwlock_recursive.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/schedule.h b/include/odp/arch/default-linux/odp/api/abi/schedule.h
new file mode 100644
index 000000000..027265c1b
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/schedule.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/schedule.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/schedule_types.h b/include/odp/arch/default-linux/odp/api/abi/schedule_types.h
new file mode 100644
index 000000000..f9aa2005d
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/schedule_types.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/schedule_types.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/shared_memory.h b/include/odp/arch/default-linux/odp/api/abi/shared_memory.h
new file mode 100644
index 000000000..51e35e902
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/shared_memory.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/shared_memory.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/spinlock.h b/include/odp/arch/default-linux/odp/api/abi/spinlock.h
new file mode 100644
index 000000000..46da3024e
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/spinlock.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/spinlock.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/spinlock_recursive.h b/include/odp/arch/default-linux/odp/api/abi/spinlock_recursive.h
new file mode 100644
index 000000000..e75e753e8
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/spinlock_recursive.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/spinlock_recursive.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/std_clib.h b/include/odp/arch/default-linux/odp/api/abi/std_clib.h
new file mode 100644
index 000000000..048c9fc23
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/std_clib.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/std_clib.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/std_types.h b/include/odp/arch/default-linux/odp/api/abi/std_types.h
new file mode 100644
index 000000000..fa360e010
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/std_types.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/std_types.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/sync.h b/include/odp/arch/default-linux/odp/api/abi/sync.h
new file mode 100644
index 000000000..cdab3a945
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/sync.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/sync.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/thread.h b/include/odp/arch/default-linux/odp/api/abi/thread.h
new file mode 100644
index 000000000..e34b7c7be
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/thread.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/thread.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/thrmask.h b/include/odp/arch/default-linux/odp/api/abi/thrmask.h
new file mode 100644
index 000000000..14ff77702
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/thrmask.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/thrmask.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/ticketlock.h b/include/odp/arch/default-linux/odp/api/abi/ticketlock.h
new file mode 100644
index 000000000..268b80948
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/ticketlock.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/ticketlock.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/time.h b/include/odp/arch/default-linux/odp/api/abi/time.h
new file mode 100644
index 000000000..85c7dd03f
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/time.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/time.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/timer.h b/include/odp/arch/default-linux/odp/api/abi/timer.h
new file mode 100644
index 000000000..b16649597
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/timer.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/timer.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/traffic_mngr.h b/include/odp/arch/default-linux/odp/api/abi/traffic_mngr.h
new file mode 100644
index 000000000..fcd838011
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/traffic_mngr.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/traffic_mngr.h>
diff --git a/include/odp/arch/default-linux/odp/api/abi/version.h b/include/odp/arch/default-linux/odp/api/abi/version.h
new file mode 100644
index 000000000..36559ec84
--- /dev/null
+++ b/include/odp/arch/default-linux/odp/api/abi/version.h
@@ -0,0 +1,7 @@
+/* Copyright (c) 2018, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:     BSD-3-Clause
+ */
+
+#include <odp/api/abi-default/version.h>